代码随想录算法训练营第1天| 704. 二分查找 、 27. 移除元素

代码随想录算法训练营第1天| 704. 二分查找27. 移除元素

704.二分查找

有序数组(本题是有序),查找问题,可以使用二分查找,降低时间复杂度,本题使用的内部构造是左闭右闭区间。

class Solution {
public:
    int search(vector<int>& nums, int target) {
        int left = 0, right = nums.size() - 1, mid = 0;
        while (left <= right) {
            //预防越界
            int mid = left + (right -left) / 2;
            if (nums[mid] == target) {
                return mid;
            } else if (nums[mid] > target) {
                right = mid - 1;
            } else if (nums[mid] < target) {
                left = mid + 1;
            }
        }
        return -1; // not found;
    }
};
27. 移除元素

第一个想到的就是暴力解法,两层的遍历,第一层是比较是否找到了目标元素,第二个循环就是循环移位。

class Solution{
public:
    int removeElement(vector<int>& nums, int val) {
        int size = nums.size();
        for (int i = 0; i < size; ++i) {
            if (nums[i] == val) {
                for (int j = i + 1; j < size; ++j) {
                    nums[j - 1] = nums[j];
                }
                // after an element deleted, need to update the value of i;
                i--; 
            	size--;
            }
        }
        return size;
    }
};

第二个想到的就是使用双指针(快慢指针),题目要求是元素的相对顺序可以改变。因此又有两个变化,一个是相对顺序不改变,另一个就是相对顺序可以改变。

// do not consider keep the relative order
class Solution {
public:
    int removeElement(vector<int>& nums, int val) {
        int size = nums.size();
        int left = 0, right = size - 1;
        while (left <= right) {
            // find the target which is  target from the left
            while (nums[left] != val && left <= right) {
                ++left;
            }
            // to find the value which is not the target from the right
            while (nums[right] == val && left <= right) {
                --right;
            }
            // to swap the value of two target
            if (left < right) {
                nums[left] = nums[right];
                left++;
                right--;
            }
        }
        // left is pointed to the next value of the end of the array
        return left;
    }
};
// to consider the relative order
class Solution {
public:
    int removeElement(vector<int>& nums, int val) {
        int slow = 0, fast = 0, size = nums.size();
        while (fast < size) {
            if (nums[fast] == val) {
                fast++;
            } else {
                nums[slow] = nums[fast];
                slow++;
                fast++;
            }
        }
        return slow;
    }
};
第二十二算法训练营主要涵盖了Leetcode题目中的三道题目,分别是Leetcode 28 "Find the Index of the First Occurrence in a String",Leetcode 977 "有序数组的平方",和Leetcode 209 "长度最小的子数组"。 首先是Leetcode 28题,题目要求在给定的字符串中找到第一个出现的字符的索引。思路是使用双指针来遍历字符串,一个指向字符串的开头,另一个指向字符串的结尾。通过比较两个指针所指向的字符是否相等来判断是否找到了第一个出现的字符。具体实现的代码如下: ```python def findIndex(self, s: str) -> int: left = 0 right = len(s) - 1 while left <= right: if s[left == s[right]: return left left += 1 right -= 1 return -1 ``` 接下来是Leetcode 977题,题目要求对给定的有序数组中的元素进行平方,并按照非递减的顺序返回结果。这里由于数组已经是有序的,所以可以使用双指针的方法来解决问题。一个指针指向数组的开头,另一个指针指向数组的末尾。通过比较两个指针所指向的元素的绝对值的大小来确定哪个元素的平方应该放在结果数组的末尾。具体实现的代码如下: ```python def sortedSquares(self, nums: List[int]) -> List[int]: left = 0 right = len(nums) - 1 ans = [] while left <= right: if abs(nums[left]) >= abs(nums[right]): ans.append(nums[left ** 2) left += 1 else: ans.append(nums[right ** 2) right -= 1 return ans[::-1] ``` 最后是Leetcode 209题,题目要求在给定的数组中找到长度最小的子数组,
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值